/*****************************************************************
 * File:		$RCSfile: agmdebug.h,v $
 * Date:		$Date: 2005/05/08 20:09:13 $
 * Author:		$Author: kath $
 * Revision:	$Revision: 1.2 $
 * License:		See file LICENSE
 *******************************************************************/

#ifndef __AGMDEBUG_H__
#define __AGMDEBUG_H__

#include <stdint.h>
#include <unistd.h>

enum
{
	AGM_LOG_DEBUG = 0,
	AGM_LOG_INFO,
	AGM_LOG_ERROR,
	AGM_LOG_CRITICAL
};

#define AgmLog0(priority) agm_log_msg(priority, "%s:%d:%s()", __FILE__, __LINE__, __FUNCTION__)
#define AgmLog1(priority, fmt) agm_log_msg(priority, "%s:%d:%s() " fmt, __FILE__, __LINE__, __FUNCTION__)
#define AgmLog2(priority, fmt, data) agm_log_msg(priority, "%s:%d:%s() " fmt, __FILE__, __LINE__, __FUNCTION__, data)
#define AgmLog3(priority, fmt, data1, data2) agm_log_msg(priority, "%s:%d:%s() " fmt, __FILE__, __LINE__, __FUNCTION__, data1, data2)
#define AgmLog4(priority, fmt, data1, data2, data3) agm_log_msg(priority, "%s:%d:%s() " fmt, __FILE__, __LINE__, __FUNCTION__, data1, data2, data3)
#define AgmLog5(priority, fmt, data1, data2, data3, data4 ) agm_log_msg(priority, "%s:%d:%s() " fmt, __FILE__, __LINE__, __FUNCTION__, data1, data2, data3, data4)
#define AgmLog6(priority, fmt, data1, data2, data3, data4, data5) agm_log_msg(priority, "%s:%d:%s() " fmt, __FILE__, __LINE__, __FUNCTION__, data1, data2, data3, data4, data5)
#define AgmLog7(priority, fmt, data1, data2, data3, data4, data5, data6) agm_log_msg(priority, "%s:%d:%s() " fmt, __FILE__, __LINE__, __FUNCTION__, data1, data2, data3, data4, data5, data6)
#define AgmLog8(priority, fmt, data1, data2, data3, data4, data5, data6, data7) agm_log_msg(priority, "%s:%d:%s() " fmt, __FILE__, __LINE__, __FUNCTION__, data1, data2, data3, data4, data5, data6, data7)
#define AgmLog9(priority, fmt, data1, data2, data3, data4, data5, data6, data7, data8) agm_log_msg(priority, "%s:%d:%s() " fmt, __FILE__, __LINE__, __FUNCTION__, data1, data2, data3, data4, data5, data6, data7, data8)

#define AgmLogXxd(priority, msg, buffer, size) agm_log_xxd(priority, msg, buffer, size)

void agm_log_msg(const int priority, const char *fmt, ...);
void agm_log_xxd(const int priority, const char *msg,
					  const unsigned char *buffer, const int size);

#endif // #ifndef __AGMDEBUG_H__
