/*****************************************************************
 * File:		$RCSfile: tdssccom.h,v $
 * Date:		$Date: 2005/05/18 06:57:20 $
 * Author:		$Author: dong $
 * Revision:	$Revision: 1.4 $
 * License:		See file LICENSE
 *******************************************************************/

#ifndef _TDSSCCOM_H_
#define _TDSSCCOM_H_

#define AGM_DEFAULT_TIMEOUT     1000
#define ARGMINIUSB_FIFO_LEN     8
// Main IDs

#define DataID                  0x01
#define CommandID               0x02


/* SC Commands. */

#define AGMU_No_Command         0x00
#define AGMU_ResetCard          0x01
#define AGMU_SetCardtype        0x02
#define AGMU_WriteSynch         0x03
#define AGMU_ReadSynch          0x04
#define AGMU_PgmSynch           0x05
#define AGMU_SetParam           0x06
#define AGMU_GetParam           0x07
#define AGMU_SetLED             0x08
#define AGMU_GetCardStatus      0x09
#define AGMU_CardPowerOn        0x0A
#define AGMU_CardPowerOff       0x0B
#define AGMU_UseReceiveBuffer   0x0C
#define AGMU_SetReceiveTimeout  0x0D
#define AGMU_GetFw_version      0x0E
#define AGMU_SetGuardTime       0x0F
#define AGMU_GetRomInfo         0x10
#define AGMU_SetBaudrate        0x11
#define AGMU_PTS_Data_length    0x12
#define AGMU_T0_Data_length     0x13
#define AGMU_T1_Data_length     0x14
#define AGMU_WarmReset          0x15
#define AGMU_sCard_setup        0x16

// Respons codes
#define AGMU_CardStatus_IND     0x81
#define AGMU_ParamSetting_IND   0x82
#define AGMU_Fw_version_IND     0x83
#define AGMU_GetRomInfo_IND     0x84
#define AGMU_SetBaudrate_IND    0x85
#define AGMU_T1ParityError_IND  0x86
#define AGMU_T1timeout_IND      0x87

// Error indicator
#define AGMU_Error_IND          0xA0
// Errors
#define SC_Err_No_Error         0x00
#define SC_Err_Unknown_Cmd      0x01
#define SC_Err_Param_Error      0x02
#define SC_Err_Wrong_Packet_Len 0x03
#define SC_Err_Unknown_ID       0x04

// CPU Commands.
#define AGMU_CPUEraseBlock      0x40
#define AGMU_CPUProgramStart    0x41
#define AGMU_CPUProgramData     0x42

// Led status values
#define AGMU_LED1_MASK          0x04
#define AGMU_LED2_MASK          0x08
#define AGMU_LED1_STATUS        0x01
#define AGMU_LED2_STATUS        0x02

#define AGMU_T1_BWT_timeout     0x00
#define AGMU_T1_CWT_timeout     0x01

typedef enum { S_NOCARD, S_RESET, S_RESET_ANSV, S_ASYNC} SC_Stat_V;

#endif // _TDSSCCOM_H_
